SMOTE <- function(t,N,k){
  
  if (N<100) #Se o n?mero ? menor que 100
  {
    t<-t[sample(nrow(t),as.integer(nrow(t)*N/100)), ] #tomando a porcentagem de t randomicamente
    N<-100
  }
  
  
  N<-N/10^(nchar(N)-1) #inteiro correspondente ao aumento (int)*N/100
  synth<-NULL #iniciando dados sintetica
  for (i in 1:nrow(t)){
    dista<-NULL
    for(j in 1:nrow(t)){
      dista<-rbind(dista,c(dist(rbind(t[i,],t[j,])),i,j)) #calculo dos pontos mais pr?ximos de i
    }
      dista<-dista[order(dista[,1]),] #ordenando os pontos mais pr?ximos de i
      dista<-dista[1:k+1,] #tomando os k vizinhos mais proximos de i
      synth<-populate(dista,N,t,synth) #criando novos dados a partir de i e seus vizinhos mais proximos
  }
  colnames(synth)<-colnames(t)
  
    return(synth)
}

populate<-function(Dista,n,t,synth){
  while (n!=0){
      dif<-t[Dista[1,2],]-t[sample(Dista[,3],1),] #diferen?a entre i e um dos seus vizinhos mais proximos
      gap<-runif(1,0,1) #valor aleatorio entre 0 e 1
      synth<-rbind(synth,t[Dista[1,3],]+gap*dif) # ponto entre i e seu vizinho mais pr?ximo
      n<-n-1
  }
  return(synth)
}