knnwd <- function(data,k){
  
  dx1<-data[which(data$DXCHANGE==1),]  #subseting para Normal
  dx2<-data[which(data$DXCHANGE==2),]  #subseting para MCI
  dx3<-data[which(data$DXCHANGE==3),]  #subseting para Alzheimer
  cl<-c(dx1$DXCHANGE,dx2$DXCHANGE,dx3$DXCHANGE)
  clss<-factor(cl) #transformando as classes em valores n?o numericos
  rownames(dx1)<-NULL #remover nome das linhas
  rownames(dx2)<-NULL #remover nome das linhas
  rownames(dx3)<-NULL #remover nome das linhas
  data<-rbind(dx1,dx2,dx3) #unir conjunto de treino redimensionado
  data$DXCHANGE<-NULL #remover coluna com informa??es sobre a classe
  
  
  #ptm <- proc.time()
  lista<-NULL
  dista<-NULL
  for(i in 1:nrow(data)){
    for(j in 1:nrow(data)){
      lista<-rbind(lista,c(dist(rbind(data[i,],data[j,])),i,j)) #vizinhos dos valores da menor classe, i in mincl
    }
    lista<-cbind(lista,cl) #incluindo as classes
    lista<-lista[order(lista[,1]),] #ordenameto das dist?ncias
    lista<-lista[which(xor(lista[,3]==i,lista[,2]==i)),] #elimina o elemento igual a ele mesmo
    lista<-lista[1:5,] #lista de dataframes, os m vizinhos mais proximos de i
    dista[[i]]<-lista
    lista<-NULL
  }
  #proc.time() - ptm
  
  
  #pesos
  w<-NULL
  waux<-NULL
  for(i in 1:nrow(data)){
    w_aux<-NULL
    for(j in 1:k){
      if(dista[[i]][k]==dista[[i]][1]){
        w_aux<-c(w_aux,1,dista[[1]][j,3],dista[[1]][j,4])
      } else {
        w_aux<-c((dista[[i]][k]-dista[[i]][j])/(dista[[i]][k]-dista[[i]][1]),dista[[i]][j,3],dista[[i]][j,4])
      }
  waux<-rbind(waux,w_aux)
  }
  w[[i]]<-waux
  waux<-NULL
  }
  
  data$clss<-rep(0,nrow(data))
  aux<-0
  for(i in 1:nrow(data)){
    ww[[i]]<-data.frame(w[[i]])
  }
for(i in 1:nrow(data)){
  if(sum(ww[[i]][ww[[i]][,3]==1,][,1])>aux){
  data$clss[i]<-1
  aux<-sum(ww[[i]][ww[[i]][,3]==1,][,1])
  } 
  if (sum(ww[[i]][ww[[i]][,3]==2,][,1])>aux){
    data$clss[i]<-2
    aux<-sum(ww[[i]][ww[[i]][,3]==2,][,1])
  }
  if (sum(ww[[i]][ww[[i]][,3]==3,][,1])>aux){
    data$clss[i]<-3
    aux<-sum(ww[[i]][ww[[i]][,3]==3,][,1])
  }
  aux<-0
}

dx1<-data[which(data$DXCHANGE==1),]  #subseting para Normal
dx2<-data[which(data$DXCHANGE==2),]  #subseting para MCI
dx3<-data[which(data$DXCHANGE==3),]  #subseting para Alzheimer
  
return(c(nrow(dx1[dx1$clss==1,])/nrow(dx1),nrow(dx2[dx2$clss==2,])/nrow(dx2),nrow(dx3[dx3$clss==3,])/nrow(dx3))) 
}
